@ECHO OFF
:: =====================================================
:: - Batch-Name: 3P-Rep.BAT                            -
:: =====================================================
:: -          Batch by Uwe Morgener - 05.2003          -
:: -       fuer Crosspoint (XP2/OpenXP) und UKAW       -
:: -----------------------------------------------------
:: - Zweck: rekonstruieren der 3P-/XP-Umgebung nach    -
:: - ====== einem Crash whrend eines "Nur News senden"-
:: -        Netcall                                    -
:: -----------------------------------------------------
:: - ACHTUNG: Diese Batch ruft sich selber auf. Mit    -
:: -          Anpassungen daher sehr sorgfltig um-    -
:: -          gehen, um keine Endlosschleifen zu er-   -
:: -          halten.                                  -
:: -----------------------------------------------------
:: -        (gehrt zum Paket: 3P-Batch v1.20)         -
:: -----------------------------------------------------
GOTO Start

:: -=[ Fehlermeldungen ]=- ====================================================
:isID
ECHO.
ECHO FEHLER in 3P-Rep
ECHO ================
ECHO Noch folgende temporre Dateien gefunden:
IF %isID$%'==1' ECHO   - Request.id$
IF %isID_%'==1' ECHO   - Request.id_
ECHO -= Die Reparatur der 3P-/XP-Umgebung ist fehlgeschlagen. =-
ECHO.
PAUSE
GOTO IDEnde

:noID
ECHO.
ECHO FEHLER in 3P-Rep
ECHO ================
ECHO Die Request.id konnte nicht wiederhergestellt verden.
ECHO -= Die Reparatur der 3P-/XP-Umgebung ist fehlgeschlagen. =-
ECHO.
PAUSE
GOTO IDEnde

:isLog
ECHO 3P-/XP-Umgebung erfolgreich rekonstruiert. Es konnten jedoch nicht alle
ECHO Daten einbezogen werden. Nheres entnehmen Sie bitte der Datei 3P-Rep.log,
ECHO die Sie in Ihrem 3P-Batch-Verzeichnis finden.
ECHO.
PAUSE
GOTO RCEnde

:isRC$
ECHO.
ECHO FEHLER in 3P-Rep
ECHO ================
ECHO Es konnten nicht alle *.RC$-Dateien umbenannt werden.
ECHO -= Die Reparatur der 3P-/XP-Umgebung ist fehlgeschlagen. =-
ECHO.
PAUSE
GOTO RCEnde

:NoRAM
ECHO FEHLER in 3P-Rep
ECHO ================
ECHO Laufwerk und/oder Verzeichnis "%RAM%" existiert nicht...
ECHO Definiert in der Umgebungsvariablen "RAM".
ECHO -=[ Es wird daher keine Reparatur durchgefhrt. ]=-
ECHO.
PAUSE
:: Hilfsvariablen lschen
FOR %%a IN (Err Slash_1 Slash_2) DO SET %%a=
GOTO RCEnde

:isSlash
ECHO FEHLER in 3P-Rep
ECHO ================
ECHO Verzeichnisangabe ist: "%Slash_2%"
ECHO Geben Sie das Verzeichnis ohne den abschlieenden Backslash an!
ECHO Definiert in der Umgebungsvariablen "%Slash_1%".
ECHO -=[ Es wird keine Reparatur durchgefhrt. ]=-
ECHO.
PAUSE
:: Hilfsvariablen lschen
FOR %%a IN (Err Slash_1 Slash_2) DO SET %%a=
GOTO RCEnde

:WrongXP
ECHO FEHLER in 3P-Rep
ECHO ================
ECHO 3P-Rep untersttzt den gefundenen Netztyp nicht.
ECHO.
ECHO Die folgenden Netztypen werden untersttzt:
ECHO.
ECHO        RFC/Client (z.B. OpenXP)
ECHO        RFC/PPP... (z.B. XP2)
ECHO.
ECHO -=[ Es wird keine Reparatur durchgefhrt. ]=-
ECHO.
PAUSE
GOTO RCEnde
                
:MixedBFG
ECHO FEHLER in 3P-Rep
ECHO ================
ECHO 3P-Rep hat BFG-Dateien unterschiedlicher
ECHO Crosspoint-Linien im Crosspoint-Verzeichnis
ECHO gefunden. 
ECHO.
ECHO -=[ Es wird keine Reparatur durchgefhrt. ]=-
ECHO.
PAUSE
GOTO RCEnde

:NoTemp
ECHO FEHLER in 3P-Rep
ECHO ================
ECHO Es ist kein Temporrverzeichnis definiert.
ECHO Definieren Sie dieses ber eine der nachfolgenden
ECHO Umgebungsvariablen:
ECHO         "Temp" oder "Tmp"
ECHO         "RAM"
GOTO RCEnde

:NoRep
IF %HLF%'==' SET HLF=Keine temporren Dateien gefunden, daher keine Reparatur erforderlich.
:NoESpace
IF %HLF%'==' SET HLF=Zu wenig Umgebungsspeicher vorhanden.
:RCBakErr
IF %HLF%'==' SET HLF=Backup der RC-, RC$-Files fehlerhaft.
:IDBakErr
IF %HLF%'==' SET HLF=Backup der ID-, ID$- und/oder ID_-Files fehlerhaft.
:noXP
IF %HLF%'==' SET HLF=Kann "XP.EXE" nicht finden (%%XP%% nicht definiert?).
:no3Pcom
IF %HLF%'==' SET HLF=Kann "3P.COM" nicht finden (%%PPP%% nicht/falsch definiert?).
:no3PaExe
IF %HLF%'==' SET HLF=Kann "3Pa.EXE" nicht finden (%%PPP%% nicht/falsch definiert?).
:noVarBat
IF %HLF%'==' SET HLF=Kann "VAR.BAT" nicht finden (%%PPP%% nicht/falsch definiert?).
:NoLw
IF %HLF%'==' SET HLF=Die Umgebungsvariable "PPP" enthlt keine Laufwerksangabe!
CLS
ECHO.
ECHO %HLF%
ECHO.
ECHO -=[ Es wird daher keine Reparatur durchgefhrt. ]=-
ECHO.
PAUSE
:: Hilfsvariablen wieder lschen
FOR %%S IN (HLF Dir) DO SET %%S=
:: dann keine Reparatur durchfhren
GOTO RCEnde

:: -=[ Unterprogramme (per rekursivem Aufruf gestartet) ]=- ==================
:CheckXP
:: Mischsystem erkannt, dann nur beenden
IF %XPv%'==-2' GOTO RCEnde
:: aktuelle Variable fr Test auf Mischsystem merken
SET _XPv=%XPv%
::
:: XP-Varianten-Erkennung (%XPv% = 0 = XP2; %XPv% = 1 = OpenXP)
:: Hilfsvariablen initialiseren
FOR %%S IN (PPP_UUZ_Spool, Client-Spool) DO SET %%S=
:: mgliche Schlsselworte fr die Spoolverzeichnisse einlesen
IF EXIST %2 CALL VAR GET PPP_UUZ_Spool, Client-Spool FROM %2
:: beide Variablen leer, dann unbekannte XP-Varinate
IF %Client-Spool%%PPP_UUZ_Spool%'==' SET XPv=-1
:: es ist XP2 (RFC/PPP-Box)
IF NOT %PPP_UUZ_Spool%'==' SET XPv=0
:: es ist OpenXP (RFC/Client-Box)
IF NOT %Client-Spool%'==' SET XPv=1
:: Hilfsvariablen wieder lschen
FOR %%S IN (PPP_UUZ_Spool, Client-Spool) DO SET %%S=
:: BFG-Dateien aus beiden XP-Varianten gefunden = Mischsystem
IF %XPv%%_XPv%'==10' SET XPv=-2
IF %XPv%%_XPv%'==01' SET XPv=-2
:: Hilfsvariable wieder lschen
SET _XPv=
::
GOTO RCEnde
-= E N D - S U B =- -------------------------


:Del0RC
CD %PPP%
:: Gre der *.RC-Datei
CALL VAR SET RC_Size=SIZE OF %RC_Path%\%2
CALL VAR SET RC_Name=NAME OF %RC_Path%\%2
CD %RC_Path1%
IF %RC_Size%'==0' IF EXIST %RC_Name%.RC$ DEL %RC_Name%.RC
:: existiert hier noch eine *.RC und eine *.RC$, dann kann die *.RC eigentlich
:: keine Dummy-Brett-Liste sein (ist ja nicht leer), daher protokollieren und ...
::(-- keine weitere Abfrage... luft automatisch zur richtigen Stelle --)
:: existiert hier /keine/ *.RC aber eine *.RC$, dann wurde die Dummy-
:: Brett-Liste gelscht - dies jedoch nicht protokollieren
IF NOT EXIST %RC_Name%.RC IF EXIST %RC_Name%.RC$ GOTO RCNext_2
:: existiert /keine/ *.RC$, aber eine *.RC, dann letztere /nicht/ anfassen
IF NOT EXIST %RC_Name%.RC$ IF EXIST %RC_Name%.RC GOTO RCNext_2
:: Kann im regulrem Betrieb eigentlich nicht vorkommen, da
::   [RC-Datei sichern & Dummy-RC-Datei erstellen]
:: - 3P-News.bat WDial1 IF EXIST *.RC REN *.RC *.RC$
:: - 3P-News.bat NewsRC IF EXIST <Name>.RC$ erstelle leere <Name>.RC
::   [Dummy-RC-Datei lschen & RC-Datei wieder herstellen]
:: - 3P-News.bat Hangup FOR %%D IN (*.RC) DO IF EXIST %%D$ DEL %%D
:: - 3P-News.bat Hangup IF EXIST *.RC$ REN *.RC$ *.RC
IF NOT %$Del0RC%'==' GOTO RCNext_0
%PPP%\3P LOGECHO SET _Date=$D.$M.$Y $h:$m > %RAM%\temp.bat
CALL %RAM%\temp.bat
DEL %RAM%\temp.bat
%PPP%\3P QECHO CR LF "%_Date%" >> %PPP%\3P-Rep.log
ECHO Folgende doppelte Brettlisten wurden gefunden und gelscht. >> %PPP%\3P-Rep.log
ECHO -------------------------------------------------------------------------- >> %PPP%\3P-Rep.log
SET _Date=
SET $Del0RC=1
:RCNext_0
ECHO %RC_Size% | %PPP%\3P LMod [R10] Byte - %RC_Name%.RC >> %PPP%\3P-Rep.log
:RCNext_1
:: ... anschlieend lschen (Backup existiert ja ;)
IF EXIST %RC_Name%.RC DEL %RC_Name%.RC
:RCNext_2
GOTO RCEnde
-= E N D - S U B =- -------------------------

:IDTest
:: existiert die Request.id nicht, dann Test gleich beenden
IF %3'==0' GOTO isPlaus
:: Gre der Request.id ermitteln
CALL VAR SET IDSize=SIZE OF %ID_Path%\Request.%2
::
:: Request.id auf Plausibilitt prfen (1 Datensatz hat 267 Byte)
IF %3'==1' CALL VAR SET IDPlaus=%IDSize%\267
IF %3'==0' SET IDPlaus=0
IF %IDPlaus%'==0' GOTO isPlaus
:: nicht plausible Request.id's protokollieren und ...
IF NOT %$IDTest%'==' GOTO IDNext_0
3P LOGECHO SET _Date=$D.$M.$Y $h:$m > %RAM%\temp.bat
CALL %RAM%\temp.bat
DEL %RAM%\temp.bat
3P QECHO CR LF "%_Date%" >> 3P-Rep.log
ECHO Folgende Request-Dateien sind nicht plausibel und wurden da- >> 3P-Rep.log
ECHO                her /nicht/ zur Rekonstruierung der Request.id herangezogen. >> 3P-Rep.log
ECHO --------------------------------------------------------------------------- >> 3P-Rep.log
SET $IDTest=0
:IDNext_0
ECHO %IDSize% | 3P LMod [R10] Byte - Request.%2 >> 3P-Rep.log
:: ... anschlieend lschen (Backup existiert ja ;)
DEL %ID_Path%\Request.%2
:: Request.ID auf "nicht vorhanden" setzen
SET %2=0
::
:isPlaus
FOR %%S IN (IDSize IDPlaus) DO SET %%S=
GOTO RCEnde
-= E N D - S U B =- -------------------------

:: -=[ Unterprogramme (per GOTO aufgerufen) ]=- ==============================
:Rep111
::                      DEL ID_ & REN ID ID_ & COPY ID$+ID_ ID
:: die frs Zusammenfhren (COPY /B) erstellte temporre ID_ lschen;
:: wird im nchsten Schritt wieder aus der Request.ID erstellt
DEL Request.id_
::
:Rep101
::                      REN ID ID_ & COPY ID$+ID_ ID
REN Request.id Request.id_
IF EXIST Request.id GOTO isID
::
:Rep110
::                      COPY ID$+ID_ ID
CD %PPP% >NUL
:: 0-Byte-Dateien lschen, da sie berfssig sind und nicht kopiert werden knnen
CALL VAR SET ID_Size=SIZE OF %ID_Path%\Request.id_
IF %ID_Size%'==0' DEL %ID_Path%\Request.id_
CALL VAR SET ID_Size=SIZE OF %ID_Path%\Request.id$
IF %ID_Size%'==0' DEL %ID_Path%\Request.id$
CD %ID_Path1% >NUL
:: Keine Request.id[_|$] zum Zusammenfhren vorhanden, dann "Copy" berspringen 
IF NOT EXIST Request.id_ IF NOT EXIST Request.id$ GOTO RepNoCopy
::
COPY /B  Request.id$+Request.id_ Request.id >NUL
IF NOT EXIST Request.id GOTO noID
:RepNoCopy
::                      DEL ID$ & DEL ID_
IF EXIST Request.id$ DEL Request.id$
IF EXIST Request.id_ DEL Request.id_
GOTO IDNext_1
-= E N D - S U B =- -------------------------

:: -=[ Haupt-Routine ]=- =====================================================
:Start

:: rekursiver Aufruf
IF Del0RC'==%1' GOTO %1
IF IDTest'==%1' GOTO %1
IF CheckXP'==%1' GOTO %1
:: fehlerhafter Aufruf, wenn Parameter bergeben wurde
:: und die Batch trotzdem bis hierher luft
IF NOT %1'==' GOTO RCEnde

:: -=[ Arbeitsumgebung prfen ]=- --------------------------------------------
:: existieren die Dateien mit den Batch-Utillities?
:: (weist %PPP% auf's richtige Verzeichnis?)
IF NOT EXIST %PPP%\3P.com GOTO no3Pcom
IF NOT EXIST %PPP%\3Pa.exe GOTO no3PaExe
IF NOT EXIST %PPP%\Var.bat GOTO noVarBat
:: existiert das Haupmodul von XPoint?
:: (weist %XP% auf's richtige Verzeichnis?)
IF NOT EXIST %XP%\XP.exe GOTO noXP

:: Pfade zu der Request.ID und den RC-Dateien festlegen
:: (alle BFG-Dateien durchsuchen; auf XP-Variante/-Linie prfen)
FOR %%S IN (%XP%\*.BFG) DO CALL 3P-Rep.bat CheckXP %%S
:: unbekannte XP-Variante
IF %XPv%'==-1' GOTO WrongXP
:: Mischsystem (BFG-Dateien beider XP-Varianten gefunden)
IF %XPv%'==-2' GOTO MixedBFG
::    ist XP2
IF %XPv%'==0' SET RC_Path=%XP%
IF %XPv%'==0' SET ID_Path=%XP%
::    ist OpenXP
IF %XPv%'==1' SET RC_Path=%PPP%
IF %XPv%'==1' SET ID_Path=%XP%

:: gengend Umgebungsspeicher vorhanden?
%PPP%\3P ESpace 446
IF ERRORLEVEL==1 GOTO NoESpace

:: temporres Verzeichnis (RAM-Laufwerk) gesetzt?
IF NOT %RAM%'==' GOTO RAMok
:: %RAM% nicht definiert - daher auf Default setzen
IF NOT %TMP%'==' SET RAM=%TMP%
IF NOT %TEMP%'==' SET RAM=%TEMP%
:: Default leider auch nicht gesetzt
IF %RAM%'==' GOTO NoTemp

:RAMok
:: existiert das Laufwerk/Verzeichnise (/ohne/ abschlieenden Backslash)?
:: Variable initialisieren
SET Err=
:: Temporr-Verzeichnis
CALL %PPP%\3P-Sub.BAT RAM DirExist %RAM%
IF NOT %Err%'==' GOTO %Err%

:: Laufwerk aus der Umgebungsvariablen %PPP% ermitteln
CALL VAR SET Drive=DRIVE OF %PPP%
IF Errorlevel==1 GOTO NoLw
%Drive%
SET Drive=

:: -=[ Backup erstellen ]=- --------------------------------------------------
:: Hilfsvariablen fr den Verzeichniswechsel per DOS-Befehl CD setzen
:: (Ist %RC_Path% ein Rootverzeichnis (%RC_Path%==%Drive%) eines Laufwerks, 
:: dann mu "CD \" anstatt "CD %RC_Patch%" zum Wechsel in dieses Verzeichnis
:: ausgefhrt werden)
SET RC_Path1=%RC_Path%
IF %RC_Path%'==%Drive%' SET RC_Path1=\
SET ID_Path1=%ID_Path%
IF %ID_Path%'==%Drive%' SET ID_Path1=\

:: Hilfsvariablen initialisieren
SET $Del0RC=
SET $IDTest=

:: keine temporre Dateien im XP-/3P-Batch-Verzeichnis vorhanden,
:: daher keine Reparatur notwendig
CD %ID_Path1%
IF NOT EXIST %RC_Path%\*.RC$ IF NOT EXIST *.ID$ IF NOT EXIST *.ID_ GOTO NoRep
CD %PPP%

:Loop
:: zuflligen Verzeichnisnamen generieren
3P QEcho "SET Dir=3P_" > %RAM%\temp.bat
3P Random 1,65535 >> %RAM%\temp.bat
CALL %RAM%\temp.bat
DEL %RAM%\temp.bat
:: prfen, ob Verzeichnis schon existiert
3Pa.exe DirExist %Dir%
:: wenn ja, dann neuen Namen generieren
IF NOT ERRORLEVEL==1 GOTO LOOP

:: *.RC und *.RC$ sichern 
3Pa.exe Backup %RC_Path%\*.RC? %Dir%
:: Backup-Fehler aufgetreten?
IF ERRORLEVEL==1 GOTO RCBakErr
:: Request.ID$, Request.ID_ und Request.ID sichern
3Pa.exe Backup %ID_Path%\Request.ID? %Dir%
IF ERRORLEVEL==1 GOTO IDBakErr
:: die alte 3P-Rep.log sichern (wenn vorhanden)
3Pa.exe Backup 3P-Rep.log %Dir%
SET Dir=

:: nur die Aktionen des aktuellen Reparaturlaufs proto-
:: kollieren, daher die alte 3P-rep.log lschen
IF EXIST 3P-Rep.log DEL 3P-Rep.log

:: -=[ ID-File wieder herstellen ]=- -----------------------------------------
:: Variablen initialisieren
FOR %%S IN (ID$ ID_ ID) DO SET %%S=0

CD %ID_Path1%
:: Welche Request.id sind vorhanden?
:: .ID$: Sicherheitskopie der Request.ID vor einem "News nur senden"-Netcall
::       (bei einem solchen Netcall werden keine Requests ausgefhrt - ein-
::       gehende News sind unerwnscht)
:: .ID_: temporre Request.ID fr das Zusammenfhren von Request.ID und
::       Request.ID$ per COPY /B 
:: .ID:  die Request.ID fr UKAW
IF EXIST Request.id$ SET ID$=1
IF EXIST Request.id_ SET ID_=1
IF EXIST Request.id SET ID=1

CD %PPP%
:: Request.id's auf Plausiblitt prfen, ggf. lschen & protokollieren
CALL 3P-Rep.bat IDTest ID$ %ID$%
CALL 3P-Rep.bat IDTest ID_ %ID_%
CALL 3P-Rep.bat IDTest ID %ID%

:: Request.id wieder rekonstruieren
CD %ID_Path1%
::                      REN ID_ ID (kann eigentlich nicht vorkommen)
IF %ID$%%ID_%%ID%'==010' REN Request.id_ Request.id
::                      DEL ID_
IF %ID$%%ID_%%ID%'==011' DEL Request.id_
::                      REN ID$ ID 
IF %ID$%%ID_%%ID%'==100' REN Request.id$ Request.id
::                      REN ID ID_ & COPY ID$+ID_ ID & DEL ID$ & DEL ID_
IF %ID$%%ID_%%ID%'==101' GOTO Rep101
::                      COPY ID$+ID_ ID & DEL ID$ & DEL ID_
IF %ID$%%ID_%%ID%'==110' GOTO Rep110
::                      DEL ID_ & REN ID ID_ & COPY ID$+ID_ ID & DEL ID$ & DEL ID_
IF %ID$%%ID_%%ID%'==111' GOTO Rep111
:IDNext_1
:: Hilfsvariablen wieder lschen
FOR %%S IN (ID$ ID_ ID) DO SET %%S=

CD %ID_Path1%
:: noch immer eine /temporre/ Request.id vorhanden?
FOR %%S IN (isID$ isID_) DO SET %%S=0
IF EXIST Request.id$ SET isID$=1
IF EXIST Request.id_ SET isID_=1
IF %isID$%%isID_%'==10' GOTO isID
IF %isID$%%isID_%'==01' GOTO isID
IF %isID$%%isID_%'==11' GOTO isID
:IDEnde
FOR %%S IN (isID$ isID_) DO SET %%S=

:: -=[ RC-Files wieder herstellen ]=- ----------------------------------------
CD %RC_Path1%
:: Dummy-Brett-Liste (*.RC) nur lschen, wenn diese 0Byte gro ist und auch
:: eine Kopie der originalen Brett-Liste (*.RC$) gleichen Namens existiert
IF EXIST *.RC$ FOR %%D IN (*.RC) DO CALL %PPP%\3P-Rep.bat Del0RC %%D
:: Hilfsvariablen wieder lschen
FOR %%S IN (RC_Size RC_Name) DO SET %%S=
:: *.RC$ wieder nach *.RC zurckbenennen
IF EXIST *.RC$ REN *.RC$ *.RC
:: Umbenennung erfolgreich?
IF EXIST *.RC$ GOTO isRC$

:: wurden Fehler protokolliert?
IF EXIST %PPP%\3P-Rep.log GOTO isLog
ECHO.
ECHO 3P-/XP-Umgebung erfolgreich rekonstruiert.
ECHO.

:RCEnde
:: Hilfsvariablen wieder lschen 
:: (nur, wenn die Batch nicht gerade einem rekursiver Aufruf abarbeitet)
IF %1'==' FOR %%S IN (XPv $Del0RC $IDTest) DO SET %%S=
IF %1'==' FOR %%S IN (RC_Path ID_Path RC_Path1 ID_Path1) DO SET %%S=
:: -=[ E O F ]=- -------------------------------------------------------------
